/*******************************************************************************

				     1LINER

 This  goes through a file converting each paragraph into a single line with an
 EOL (whatever is set in TSE) at the end.  It will  also  make	sure  that  all
 periods, question marks and exclamation points that are followed by spaces are
 followed by at least TWO spaces.

 Written: 01/20/94
 By:	  Jack Hazlehurst
 Modified 08/22/94 by Jack Hazlehurst
 Modified 10/17/94 by Jack Hazlehurst

*******************************************************************************/

proc OneLIner()
    integer ib, rm, ct, xt

    if isCursorInBlock() == _COLUMN_
	Warn( "The Machine does not process column blocks." )
    else
	PushPosition()			// Save our current location.
	xt = Set( ExpandTabs, OFF )	// We don't want this messing.
	rm = Set(RightMargin, MaxLineLen) // A paragraph had better not
	ct = 0				  // be longer than this!
	if isCursorInBlock()		// Block processing?
	    GotoBlockBegin()		// Yes.
	    ib = TRUE
	else
	    BegFile()			// No.
	    ib = FALSE
	endif

	repeat
	    ct = ct + 1			// Show we're busy.
	    Message( "Working.. ", ct )
	    BegLine()			// Be sure we're at start of line.
	    PushPosition()		// Wrap the paragraph to a single line,
	    WrapPara()			// then go back to start of line.
	    PopPosition()
	    lReplace( "\t", " ", "cn" ) // Remove tabs and extra spaces from
	    BegLine()			// the line, then do the extra space
	    lReplace( "{[~ ]}  #", "\1 ", "cxn" ) // padding as needed.
	    lReplace( '{[.?!]["' + "')\]}]@ }{[~ ]}", "\1 \2", "cxn" )
	until NOT Down()		// Process to end of file or until
	   or ( ib AND NOT isCursorInBlock() ) // outside of block.

	PopPosition()			// Return to starting position.
	Set(RightMargin, rm)		// Restore right margin setting.
	Set( ExpandTabs, xt )		// Restore tab expansion setting.
	Message( "Done." )
    endif

end

//
// The required "main"
//
proc main()
    OneLiner()
end
